#ifndef EDRIVER_INCLUDED
#define EDRIVER_INCLUDED

#include "EPixel.hh"
#include "Texture.hh"

class EDriver
{
public:
  EDriver(void);
  virtual ~EDriver(void);

  virtual void CreateRenderContext(void){};
  virtual void DeleteRenderContext(void){};

  virtual void PolyScanLine(unsigned sX, long startZ, unsigned eX, long endZ, unsigned yValue,
			    TexC texStart, TexC texInc, EPIXEL pixValue) = 0;

  virtual void ClearFB(EPIXEL pixValue) = 0;
  virtual void ClearDB(long depthVal) = 0;

  virtual void UpLoadTexture(Texture &rTexture, unsigned textureID) = 0;
  virtual void SetCTexture(unsigned cTextureID) = 0;

  virtual void Flush(void) = 0;
};


#endif //EDRIVER_INCLUDED
