----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    03:03:41 09/16/2006 
-- Design Name: 
-- Module Name:    block_set - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--HACK!!! this must break the transfer up into smaller chunks to prevent pix_pusher data starvation.
--right now this is handled in the driver, but this is quite tacky.

entity block_set is
	Port(
		--memory user access buss 
		mu_bus_address 	: in std_logic_vector(11 downto 0);
		mu_bus_data		: inout std_logic_vector(31 downto 0);
		mu_bus_write		: in  std_logic;
		mu_bus_strobe		: in  std_logic;
		
		block_set_irq		: out std_logic;
		block_set_select	: in std_logic;

		tvc_clock			: in std_logic;
		tvc_reset			: in std_logic;

		 --interface to the eppcu
      cmd_bus_data      : in std_logic_vector(31 downto 0);
      cmd_bus_addr      : in std_logic_vector(7 downto 0);
      cmd_bus_strobe    : in std_logic;

		epp_idle				: out std_logic
	  );
end block_set;

architecture Behavioral of block_set is

	signal fb_address_reg 	: std_logic_vector(31 downto 2) := (others => '0');
	signal fb_num_reg			: std_logic_vector(23 downto 2) := (others => '0');
	signal fb_value_reg 		: std_logic_vector(31 downto 0) := (others => '0');

	signal selected_once 	: STD_LOGIC := '0';

	TYPE BS_INT_STATE is ( BS_IDLE, BS_MCU_DRIVEN);
	signal bs_state : BS_INT_STATE := BS_IDLE;

	--signal mu_buss_data_in : std_logic_vector(31 downto 0);
	signal mu_bus_data_out : std_logic_vector(31 downto 0) := (others => '0');

begin

	--mu_buss_data_in <= mu_buss_data;
	process(mu_bus_data_out, block_set_select, mu_bus_strobe, mu_bus_write)
	begin
		if block_set_select = '1' and mu_bus_strobe = '1' and mu_bus_write = '0' then
			mu_bus_data <= mu_bus_data_out;
		else
			mu_bus_data <= (others => 'Z');
		end if;
	end process;

	process (bs_state)
	begin
		if bs_state = BS_IDLE then
			epp_idle <= '1';
		else
			epp_idle <= '0';
		end if;
	end process;

	Process (tvc_clock)
	begin
	if tvc_clock = '1' and tvc_clock'event then
	if tvc_reset = '1' then		
		bs_state <= BS_IDLE;
		block_set_irq <= '0';
	else --not reset
	   case bs_state is
	   when BS_IDLE =>
         if cmd_bus_strobe = '1' then
            case cmd_bus_addr is
            when X"01" =>
               fb_address_reg <= cmd_bus_data(31 downto 2);
            when X"02" =>
               fb_num_reg	<= cmd_bus_data(23 downto 2);
            when X"03" =>
               fb_value_reg <= cmd_bus_data(31 downto 0);
            when X"04" =>
               bs_state <= BS_MCU_DRIVEN;
               selected_once <= '0';
               block_set_irq <= '1';
            when others =>
               null;
            end case;
        end if;
		when BS_MCU_DRIVEN =>
         if block_set_select = '0' and selected_once = '1' then
            bs_state <= BS_IDLE;
            block_set_irq <= '0';
          elsif block_set_select = '1' then
            selected_once <= '1';
            if mu_bus_address = X"FFC" and mu_bus_write = '0' and mu_bus_strobe = '1' then
               mu_bus_data_out <= X"80" & fb_num_reg & "00";
            elsif mu_bus_address = X"FFD" and mu_bus_write = '0' and mu_bus_strobe = '1' then
               mu_bus_data_out <= fb_address_reg & "00";
            elsif mu_bus_write = '0' and mu_bus_strobe = '1' then
               mu_bus_data_out <= fb_value_reg;
            end if;
         end if;
		end case;
	end if; --reset
	end if; --clock
	end process;

end Behavioral;

